
; CC5X Version 3.2I, Copyright (c) B Knudsen Data
; C compiler for the PICmicro family
; ************  29. Jun 2006  14:31  *************

	processor  16F676
	radix  DEC

	__config 0x318C

PCL         EQU   0x02
STATUS      EQU   0x03
PORTA       EQU   0x05
TRISA       EQU   0x85
PCLATH      EQU   0x0A
Carry       EQU   0
Zero_       EQU   2
RP0         EQU   5
GIE         EQU   7
OPTION_REG  EQU   0x81
PORTC       EQU   0x07
TMR1L       EQU   0x0E
TMR1H       EQU   0x0F
T1CON       EQU   0x10
CMCON       EQU   0x19
ADRESH      EQU   0x1E
ADCON0      EQU   0x1F
TRISC       EQU   0x87
PIE1        EQU   0x8C
OSCCAL      EQU   0x90
ANSEL       EQU   0x91
ADRESL      EQU   0x9E
ADCON1      EQU   0x9F
PEIE        EQU   6
TMR1IF      EQU   0
GO          EQU   1
ADIE        EQU   6
SERVO       EQU   2
LED         EQU   5
LCD_E       EQU   4
Servo       EQU   0x2E
ServoStart  EQU   0
prevWidth   EQU   0x31
svrWREG     EQU   0x20
svrSTATUS   EQU   0x21
sv_PCLATH   EQU   0x22
width       EQU   0x23
aTs         EQU   0x2C
i           EQU   0x2D
aTs_2       EQU   0x25
c           EQU   0x2A
c_2         EQU   0x2A
c_3         EQU   0x25
p           EQU   0x25
i_2         EQU   0x26
lbCommand   EQU   0
c_5         EQU   0x29
p_2         EQU   0x25
i_3         EQU   0x26
n           EQU   0x27
i_4         EQU   0x29
n_2         EQU   0x7F
i_5         EQU   0x7F
CH3Voltage  EQU   0x32
piADChannel EQU   0x28
a           EQU   0x29
u           EQU   0x2A
i_6         EQU   0x27
C1cnt       EQU   0x28
x           EQU   0x25
Beep10ms    EQU   0x7F
Pause10ms   EQU   0x7F
ci          EQU   0x2A

	GOTO main

  ; FILE ServoThrowTest.c
			;#define PIC16F676
			;
			;#define LCD
			;
			;#include "16f676.h"
			;#pragma config |= 0x318C // INT OSC; 318C with Watch Dog;
			;
			;#pragma update_RP 1

  ; FILE ServoThrowTest.c
			;
			;typedef unsigned char byte;
			;typedef unsigned long int LONG;
			;typedef bit BOOL;
			;
			;//--- PORT DEFINITIONS ---------------------------------------------------
			;//               76543210
			;#define  TrisA 0b00011000                
			;//               ||||||||
			;//               |||||||
			;//               ||||||
			;//               |||||SERVO
			;//               ||||BUTTON
			;//               |||CH3
			;//               ||LED
			;//               |---
			;//               ---
			;
			;//               76543210
			;#define  TrisC 0b00000000
			;//               ||||||||
			;//               |||||||D4
			;//               ||||||D5
			;//               |||||D6 
			;//               ||||D7
			;//               |||E 
			;//               ||A0
			;//               |---
			;//               ---
			;
			;// LCD connector;
			;// 1   2   3   4   5   6   7   8   9   10
			;// GND U+  A0  E   D4  D5  D6  D7  UBL+
			;
			;#pragma  bit ACCELX   @ PORTA.0   //        - PIC-13
			;#pragma  bit ACCELY   @ PORTA.1   //        - PIC-12
			;#pragma  bit SERVO    @ PORTA.2   //        - PIC-11
			;#pragma  bit BUTTON   @ PORTA.3   //        - PIC-4 
			;#pragma  bit CH3      @ PORTA.4   //        - PIC-3 
			;#pragma  bit LED      @ PORTA.5   //        - PIC-2 
			;
			;#pragma  bit LCD_A0   @ PORTC.5   // LCD-4  - PIC-5 
			;#pragma  bit LCD_E    @ PORTC.4   // LCD-6  - PIC-6 
			;#pragma  bit LCD_D4   @ PORTC.0   // LCD-11 - PIC-10
			;#pragma  bit LCD_D5   @ PORTC.1   // LCD-12 - PIC-9
			;#pragma  bit LCD_D6   @ PORTC.2   // LCD-13 - PIC-8
			;#pragma  bit LCD_D7   @ PORTC.3   // LCD-14 - PIC-7
			;
			;#define BUTTON_PRESSED 1
			;//------------------------------------------------------------------------
			;
			;#include "int16CXX.H"
			;
			;#define SET_RP0 
			;//#asm \
			;//BSF   0x03,RP0 \
			;//#endasm
			;
			;#define CLR_RP0 
			;//#asm \
			;//BCF   0x03,RP0 \
			;//#endasm
			;
			;LONG Servo;
			;bit  ServoStart;
			;byte prevWidth;
			;
			;#define SERVO_PERIOD	20000
			;#define SERVO_NEUTRAL	1500
			;#define SERVO_SPAN	500
			;#define SERVO_HIGH	100
			;#define SERVO_MAX (SERVO_NEUTRAL+SERVO_SPAN)
			;#define SERVO_START	500
			;
			;#pragma origin 4
	ORG 0x0004
			;interrupt serverX( void)
			;{
serverX
			;/* W and STATUS are saved by the next macro. PCLATH is also
			;   saved if necessary. The code produced is CPU-dependent. */
			;
			;int_save_registers    // W, STATUS (and PCLATH if required)
			;; #define  int_save_registers  \
			;;    char svrWREG, svrSTATUS;  \
			;;    svrWREG = W;  \
	MOVWF svrWREG
			;;    svrSTATUS = swap(STATUS);
	SWAPF STATUS,W
	MOVWF svrSTATUS
			;//char sv_FSR = FSR;  // save FSR if required
			;char sv_PCLATH = PCLATH; // save PCLATH
	MOVF  PCLATH,W
	MOVWF sv_PCLATH
			;
			;  // handle the interrupt (insert application code here)
			;
			;   CLR_RP0;
			;   T1CON = 0b00000000; // Stop timer;
	BCF   0x03,RP0
	CLRF  T1CON
			;
			;   LONG width;
			;   if (ServoStart == 0) {
	BTFSC 0x30,ServoStart
	GOTO  m001
			;     SERVO = 1; 
	BSF   0x05,SERVO
			;     ServoStart = 1;
	BSF   0x30,ServoStart
			;     width = Servo;
	MOVF  Servo,W
	MOVWF width
	MOVF  Servo+1,W
	MOVWF width+1
			;     prevWidth = width;
	MOVF  width,W
	MOVWF prevWidth
			;   } else {
	GOTO  m002
			;     width = SERVO_PERIOD-prevWidth;
m001	MOVLW .78
	MOVWF width+1
	MOVF  prevWidth,W
	SUBLW .32
	MOVWF width
	BTFSS 0x03,Carry
	DECF  width+1,1
			;     SERVO = 0;
	BCF   0x03,RP0
	BCF   0x05,SERVO
			;     ServoStart = 0;
	BCF   0x30,ServoStart
			;   }
			;   if (width == 0)
m002	MOVF  width,W
	IORWF width+1,W
	BTFSS 0x03,Zero_
	GOTO  m003
			;     width.low8 = 1;
	MOVLW .1
	MOVWF width
			;   width = -width;
m003	COMF  width+1,1
	COMF  width,1
	INCF  width,1
	BTFSC 0x03,Zero_
	INCF  width+1,1
			;
			;   TMR1H = width.high8;
	MOVF  width+1,W
	BCF   0x03,RP0
	MOVWF TMR1H
			;   TMR1L = width.low8;
	MOVF  width,W
	MOVWF TMR1L
			;
			;   T1CON = 0b00000001; // Resume counting;
	MOVLW .1
	MOVWF T1CON
			;   TMR1IF = 0;         
	BCF   0x0C,TMR1IF
			;
			;PCLATH = sv_PCLATH;    // restore PCLATH
	MOVF  sv_PCLATH,W
	MOVWF PCLATH
			;//FSR = sv_FSR;       // restore FSR if saved
			;int_restore_registers // W, STATUS (and PCLATH if required)
			;; #define  int_restore_registers \
			;;    STATUS = swap(svrSTATUS);  \
	SWAPF svrSTATUS,W
	MOVWF STATUS
			;;    svrWREG = swap(svrWREG);  \
	SWAPF svrWREG,1
			;;    W = swap(svrWREG);
	SWAPF svrWREG,W
			;}
	RETFIE
			;
			;//#include "BIN\MATH16.H"
			;
			;//--- PAUSE MAKING FUNCTIONS ---------------------------------------------
			;void Delay100us (byte aTs) // pause for aTs*100 us;
			;{ // 4+x*3 us = 4+3*32=100 us;
_const1
	MOVWF ci
	MOVLW .11
	SUBWF ci,W
	BTFSC 0x03,Carry
	RETLW .0
	CLRF  PCLATH
	MOVF  ci,W
	ADDWF PCL,1
	RETLW .40
	RETLW .12
	RETLW .6
	RETLW .15
	RETLW .1
	RETLW .0
	RETLW .84
	RETLW .101
	RETLW .115
	RETLW .116
	RETLW .0
Delay100us
	MOVWF aTs
			; do  {
			;     char i = 33;            /* 2 IS */
m004	MOVLW .33
	MOVWF i
			;     do ; while ( --i > 0);  /* 26 * 3 - 1 = 77 IS */
m005	DECFSZ i,1
	GOTO  m005
			; } while ( --aTs > 0);         /* 3 IS */
	DECFSZ aTs,1
	GOTO  m004
			;}
	RETURN
			;
			;void Delay10ms (byte aTs) // pause for aTs*10 ms;
			;{
Delay10ms
	MOVWF aTs_2
			; for (; aTs > 0; aTs--) {
m006	MOVF  aTs_2,1
	BTFSC 0x03,Zero_
	GOTO  m007
			;   Delay100us (100);
	MOVLW .100
	CALL  Delay100us
			;   clrwdt();
	CLRWDT
			; }
	DECF  aTs_2,1
	GOTO  m006
			;}
m007	RETURN

  ; FILE lcd.c
			;#ifdef LCD
			;
			;// LCD connector;
			;// 1   2   3   4   5   6   7   8   9   
			;// GND U+  A0  E   D4  D5  D6  D7  UBL+
			;
			;//--- LCD FUNCTIONS ------------------------------------------------------
			;
			;#define LCD_A0_mask 0b00100000
			;#define LCD_DD_mask 0b00001111
			;
			;#define LCD_DELAY_BASE_100_US 1
			;
			;void lcdWrite (char c) {
lcdWrite
	MOVWF c
			;  // high data byte;
			;  c = swap(c);
	SWAPF c,1
			;  PORTC = (c & LCD_DD_mask) | LCD_A0_mask; LCD_E = 1; nop(); LCD_E = 0;
	MOVLW .15
	ANDWF c,W
	IORLW .32
	BCF   0x03,RP0
	MOVWF PORTC
	BSF   0x07,LCD_E
	NOP  
	BCF   0x07,LCD_E
			;  Delay100us (LCD_DELAY_BASE_100_US);
	MOVLW .1
	CALL  Delay100us
			;  // low data byte;
			;  c = swap(c);
	SWAPF c,1
			;  PORTC = (c & LCD_DD_mask) | LCD_A0_mask; LCD_E = 1; nop(); LCD_E = 0;
	MOVLW .15
	ANDWF c,W
	IORLW .32
	MOVWF PORTC
	BSF   0x07,LCD_E
	NOP  
	BCF   0x07,LCD_E
			;  Delay100us (LCD_DELAY_BASE_100_US);
	MOVLW .1
	GOTO  Delay100us
			;}
			;
			;void lcdCommand (char c) {
lcdCommand
	MOVWF c_2
			;  // high data byte;
			;  c = swap(c);
	SWAPF c_2,1
			;  PORTC = (c & LCD_DD_mask); LCD_E = 1; nop(); LCD_E = 0;
	MOVLW .15
	ANDWF c_2,W
	BCF   0x03,RP0
	MOVWF PORTC
	BSF   0x07,LCD_E
	NOP  
	BCF   0x07,LCD_E
			;  Delay100us (LCD_DELAY_BASE_100_US);
	MOVLW .1
	CALL  Delay100us
			;  // low data byte;
			;  c = swap(c);
	SWAPF c_2,1
			;  PORTC = (c & LCD_DD_mask); LCD_E = 1; nop(); LCD_E = 0;
	MOVLW .15
	ANDWF c_2,W
	MOVWF PORTC
	BSF   0x07,LCD_E
	NOP  
	BCF   0x07,LCD_E
			;  Delay100us (LCD_DELAY_BASE_100_US);
	MOVLW .1
	GOTO  Delay100us
			;}
			;
			;void lcdCommand8 (char c) {
lcdCommand8
	MOVWF c_3
			;  PORTC = c; LCD_E = 1; nop(); LCD_E = 0;
	MOVF  c_3,W
	BCF   0x03,RP0
	MOVWF PORTC
	BSF   0x07,LCD_E
	NOP  
	BCF   0x07,LCD_E
			;  Delay100us (LCD_DELAY_BASE_100_US);
	MOVLW .1
	GOTO  Delay100us
			;}
			;
			;#define LCD_CMD_POS1		( 0x80 )
			;#define LCD_CMD_POS2		(0x80 | 0x40)
			;
			;#define LCD_CURSOR_ON		lcdCommand (0xC | 0x2);
			;#define LCD_CURSOR_OFF		lcdCommand (0xC);
			;#define LCD_CURSOR_BLINK_ON	lcdCommand (0xC | 0x2 | 0x1);
			;#define LCD_CLEAR		{ lcdCommand (0x1); Delay100us (15+LCD_DELAY_BASE_100_US); }
			;#define LCD_CURSOR_HOME		lcdCommand (0x2);
			;#define LCD_SHIFT_CURSOR_LEFT	lcdCommand (0x10);
			;#define LCD_SHIFT_CURSOR_RIGHT	lcdCommand (0x10 | 0x4);
			;#define LCD_SHIFT_DISPLAY_LEFT	lcdCommand (0x10 | 0x8);
			;#define LCD_SHIFT_DISPLAY_RIGHT	lcdCommand (0x10 | 0x8 | 0x4);
			;#define LCD_CURSOR_LINE_1(x)	lcdCommand (LCD_CMD_POS1 | x);
			;#define LCD_CURSOR_LINE_2(x)	lcdCommand (LCD_CMD_POS2 | x);
			;
			;void lcdProgram (const char * p) {
lcdProgram
			;  byte i;
			;  BOOL lbCommand = 1;
	BSF   0x28,lbCommand
			;  char c;
			;  for (i = 0; ; i++) {
	CLRF  i_2
			;    char c = p[i];
m008	MOVF  i_2,W
	ADDWF p,W
	CALL  _const1
	MOVWF c_5
			;    if (c == 0)
	MOVF  c_5,1
	BTFSC 0x03,Zero_
			;      return;
	RETURN
			;    if (lbCommand) {
	BTFSS 0x28,lbCommand
	GOTO  m009
			;      lcdCommand (c);
	MOVF  c_5,W
	CALL  lcdCommand
			;      if (c & LCD_CMD_POS1) // output character after cursor placement command;
	BTFSS c_5,7
	GOTO  m010
			;        lbCommand = 0;
	BCF   0x28,lbCommand
			;    } else {
	GOTO  m010
			;      lcdWrite (c);
m009	MOVF  c_5,W
	CALL  lcdWrite
			;      lbCommand = 1;
	BSF   0x28,lbCommand
			;    }
			;  }
m010	INCF  i_2,1
	GOTO  m008
			;}
			;
			;void lcdWriteln (const char * p) {
lcdWriteln
			;  byte i;
			;  for (i = 0; p[i] != 0; i++) {
	CLRF  i_3
m011	MOVF  i_3,W
	ADDWF p_2,W
	CALL  _const1
	XORLW .0
	BTFSC 0x03,Zero_
	GOTO  m012
			;      lcdWrite(p[i]);
	MOVF  i_3,W
	ADDWF p_2,W
	CALL  _const1
	CALL  lcdWrite
			;  }
	INCF  i_3,1
	GOTO  m011
			;}
m012	RETURN
			;
			;const char LCD_Data_Init[] = {
			;  0x28, //  
			;  0x0C, //  
			;  0x6,  //     
			;  0x0F, //     
			;//  0x80, //  
			;//  ' ',
			;  0x01,  // ,  
			;  0
			;};
			;
			;void LCD_Init() { // 16s2d
LCD_Init
			;  PORTC = 0;
	BCF   0x03,RP0
	CLRF  PORTC
			;  Delay10ms (5);
	MOVLW .5
	CALL  Delay10ms
			;
			;// 30h  
			;  lcdCommand8 (3);
	MOVLW .3
	CALL  lcdCommand8
			;  lcdCommand8 (3);
	MOVLW .3
	CALL  lcdCommand8
			;  lcdCommand8 (3);
	MOVLW .3
	CALL  lcdCommand8
			;
			;// 20h  
			;  lcdCommand8 (2);
	MOVLW .2
	CALL  lcdCommand8
			;
			;//4bit
			;  lcdProgram (LCD_Data_Init);
	CLRF  p
	CALL  lcdProgram
			;  Delay100us (15);
	MOVLW .15
	GOTO  Delay100us
			;}
			;
			;void WriteNum (LONG n) {
WriteNum
			;  byte i = '0';
	MOVLW .48
	MOVWF i_4
			;  while (n >= 1000) {
m013	MOVLW .3
	SUBWF n+1,W
	BTFSS 0x03,Carry
	GOTO  m015
	BTFSS 0x03,Zero_
	GOTO  m014
	MOVLW .232
	SUBWF n,W
	BTFSS 0x03,Carry
	GOTO  m015
			;    n -= 1000;
m014	MOVLW .3
	SUBWF n+1,1
	MOVLW .232
	SUBWF n,1
	BTFSS 0x03,Carry
	DECF  n+1,1
			;    i++;
	INCF  i_4,1
			;  }
	GOTO  m013
			;  lcdWrite (i);
m015	MOVF  i_4,W
	CALL  lcdWrite
			;
			;  i = '0';
	MOVLW .48
	MOVWF i_4
			;  while (n >= 100) {
m016	MOVF  n+1,W
	BTFSS 0x03,Zero_
	GOTO  m017
	MOVLW .100
	SUBWF n,W
	BTFSS 0x03,Carry
	GOTO  m018
			;    n -= 100;
m017	MOVLW .100
	SUBWF n,1
	BTFSS 0x03,Carry
	DECF  n+1,1
			;    i++;
	INCF  i_4,1
			;  }
	GOTO  m016
			;  lcdWrite (i);
m018	MOVF  i_4,W
	CALL  lcdWrite
			;
			;  i = '0';
	MOVLW .48
	MOVWF i_4
			;  while (n >= 10) {
m019	MOVF  n+1,W
	BTFSS 0x03,Zero_
	GOTO  m020
	MOVLW .10
	SUBWF n,W
	BTFSS 0x03,Carry
	GOTO  m021
			;    n -= 10;
m020	MOVLW .10
	SUBWF n,1
	BTFSS 0x03,Carry
	DECF  n+1,1
			;    i++;
	INCF  i_4,1
			;  }
	GOTO  m019
			;  lcdWrite (i);
m021	MOVF  i_4,W
	CALL  lcdWrite
			;  lcdWrite (n+'0');
	MOVLW .48
	ADDWF n,W
	GOTO  lcdWrite
			;}
			;
			;void WriteSNum (int n) {
WriteSNum
			;  if (n < 0) {
	BTFSS n_2,7
	GOTO  m022
			;    lcdWrite ('-');
	MOVLW .45
	CALL  lcdWrite
			;    n = -n;    
	COMF  n_2,1
	INCF  n_2,1
			;  } else {
	GOTO  m023
			;    lcdWrite ('+');
m022	MOVLW .43
	CALL  lcdWrite
			;  }
			;
			;  byte i = '0';
m023	MOVLW .48
	MOVWF i_5
			;  while (n >= 100) {
m024	BTFSC n_2,7
	GOTO  m025
	MOVLW .100
	SUBWF n_2,W
	BTFSS 0x03,Carry
	GOTO  m025
			;    n -= 100;
	MOVLW .100
	SUBWF n_2,1
			;    i++;
	INCF  i_5,1
			;  }
	GOTO  m024
			;  lcdWrite (i);
m025	MOVF  i_5,W
	CALL  lcdWrite
			;
			;  i = '0';
	MOVLW .48
	MOVWF i_5
			;  while (n >= 10) {
m026	BTFSC n_2,7
	GOTO  m027
	MOVLW .10
	SUBWF n_2,W
	BTFSS 0x03,Carry
	GOTO  m027
			;    n -= 10;
	MOVLW .10
	SUBWF n_2,1
			;    i++;
	INCF  i_5,1
			;  }
	GOTO  m026
			;  lcdWrite (i);
m027	MOVF  i_5,W
	CALL  lcdWrite
			;  lcdWrite (n+'0');
	MOVLW .48
	ADDWF n_2,W
	GOTO  lcdWrite
			;}

  ; FILE ServoThrowTest.c
			;
			;/*
			;void DelayMs (unsigned char aTs) // pause for aTs*1 ms;
			;{
			; for (; aTs > 0; aTs--) {
			;   clrwdt();
			;   Delay100us (10);
			; }
			;}
			;*/
			;
			;#include "lcd.c"
			;
			;void InitServo() {
InitServo
			;  // init channels;
			;  Servo = SERVO_NEUTRAL;
	MOVLW .220
	MOVWF Servo
	MOVLW .5
	MOVWF Servo+1
			;}
	RETURN
			;
			;//--- ANALOG SETUP DATA --------------------------------------------------
			;#define ADChannel_CH3		3
			;
			;LONG CH3Voltage;
			;
			;#define NUM_VOLTAGE_SAMPLES     8  // 2, 4, 8, 16
			;
			;LONG ReadADC(byte piADChannel) {
ReadADC
	MOVWF piADChannel
			;  CLR_RP0;
			;  byte a = (piADChannel << 2);
	BCF   0x03,Carry
	RLF   piADChannel,W
	MOVWF a
	BCF   0x03,Carry
	RLF   a,1
			;  ADCON0 = (ADCON0 & 0b111.000.11) | a;
	MOVLW .227
	BCF   0x03,RP0
	ANDWF ADCON0,W
	IORWF a,W
	MOVWF ADCON0
			;  Delay100us(10);
	MOVLW .10
	CALL  Delay100us
			;  GO = 1;
	BSF   0x1F,GO
			;  while (GO) { };
m028	BCF   0x03,RP0
	BTFSC 0x1F,GO
	GOTO  m028
			;
			;  long unsigned int u;
			;  u.high8 = ADRESH;
	BCF   0x03,RP0
	MOVF  ADRESH,W
	MOVWF u+1
			;  SET_RP0;
			;  u.low8 = ADRESL;
	BSF   0x03,RP0
	MOVF  ADRESL,W
	MOVWF u
			;  CLR_RP0;
			;  return u;
	MOVF  u,W
	RETURN
			;}
			;
			;void ReadChannels() {
ReadChannels
			;  CH3Voltage = 0;
	CLRF  CH3Voltage
	CLRF  CH3Voltage+1
			;  signed int i = NUM_VOLTAGE_SAMPLES;
	MOVLW .8
	MOVWF i_6
			;  while (i > 0) {
m029	BTFSC i_6,7
	GOTO  m030
	MOVF  i_6,1
	BTFSC 0x03,Zero_
	GOTO  m030
			;    CH3Voltage += ReadADC(ADChannel_CH3);
	MOVLW .3
	CALL  ReadADC
	MOVF  u+1,W
	ADDWF CH3Voltage+1,1
	MOVF  u,W
	ADDWF CH3Voltage,1
	BTFSC 0x03,Carry
	INCF  CH3Voltage+1,1
			;    i--;
	DECF  i_6,1
			;  }
	GOTO  m029
			;
			;  CH3Voltage /= NUM_VOLTAGE_SAMPLES; // 1:1
m030	MOVLW .3
	MOVWF C1cnt
m031	BCF   0x03,Carry
	RRF   CH3Voltage+1,1
	RRF   CH3Voltage,1
	DECFSZ C1cnt,1
	GOTO  m031
			;}
	RETURN
			;
			;// Find if channels Cell1, Cell2, Cell3 and Temp are available;
			;void ReadAndOutputAvailableChannels() {
ReadAndOutputAvailableChannels
			;  ReadChannels();
	CALL  ReadChannels
			;
			;  signed long x = (((signed long) CH3Voltage)-1023/2);
	DECF  CH3Voltage+1,W
	MOVWF x+1
	INCF  CH3Voltage,W
	MOVWF x
	BTFSS 0x03,Zero_
	DECF  x+1,1
			;  x*=2;
	BCF   0x03,Carry
	RLF   x,1
	RLF   x+1,1
			;  x+= SERVO_NEUTRAL;
	MOVLW .5
	ADDWF x+1,1
	MOVLW .220
	ADDWF x,1
	BTFSC 0x03,Carry
	INCF  x+1,1
			;  if (x < 0) x=0;
	BTFSS x+1,7
	GOTO  m032
	CLRF  x
	CLRF  x+1
			;
			;  GIE = 0;
m032	BCF   0x0B,GIE
			;  Servo = (LONG) x;
	MOVF  x,W
	MOVWF Servo
	MOVF  x+1,W
	MOVWF Servo+1
			;  GIE = 1;
	BSF   0x0B,GIE
			;
			;#ifdef LCD
			;  LCD_CURSOR_LINE_1 (0);  WriteNum (CH3Voltage);
	MOVLW .128
	CALL  lcdCommand
	MOVF  CH3Voltage,W
	MOVWF n
	MOVF  CH3Voltage+1,W
	MOVWF n+1
	CALL  WriteNum
			;  LCD_CURSOR_LINE_2 (0);  WriteNum (Servo);
	MOVLW .192
	CALL  lcdCommand
	MOVF  Servo,W
	MOVWF n
	MOVF  Servo+1,W
	MOVWF n+1
	GOTO  WriteNum
			;#endif
			;}
			;
			;void Beep(byte Beep10ms, byte Pause10ms) {
Beep
	MOVWF Pause10ms
			;  LED=1;
	BCF   0x03,RP0
	BSF   0x05,LED
			;  Delay10ms(Beep10ms);
	MOVF  Beep10ms,W
	CALL  Delay10ms
			;  LED=0;
	BCF   0x05,LED
			;  Delay10ms(Pause10ms);
	MOVF  Pause10ms,W
	GOTO  Delay10ms
			;}
			;
			;char GetOsccal();							// Defined at end of file
			;
			;void main() {
main
			;  W = GetOsccal();						// Set built-in oscillator calibration
	CALL  GetOsccal
			;  SET_RP0;
			;  OSCCAL = W;
	BSF   0x03,RP0
	MOVWF OSCCAL
			;  
			;  TRISA = TrisA;
	MOVLW .24
	MOVWF TRISA
			;  TRISC = TrisC;
	CLRF  TRISC
			;  OPTION = 0b11001110; // no pull-up, int/b0 on 0->1; Prescalder 64 -> ~1 sec. to WDT;
	MOVLW .206
	MOVWF OPTION_REG
			;  CLR_RP0;
			;  PORTA = 0; 
	BCF   0x03,RP0
	CLRF  PORTA
			;  PORTC = 0;
	CLRF  PORTC
			;
			;  CMCON = 0b.0000.0111; // comparator is turned off;
	MOVLW .7
	MOVWF CMCON
			;
			;  SET_RP0;
			;  ANSEL = (1 << ADChannel_CH3);
	MOVLW .8
	BSF   0x03,RP0
	MOVWF ANSEL
			;
			;  ADCON1 = 0b0.101.0000;      //  Select the Clock as Fosc/16
	MOVLW .80
	MOVWF ADCON1
			;
			;  ADIE = 0;
	BCF   0x8C,ADIE
			;
			;  CLR_RP0;
			;  ADCON0 = 0b10.0.000.01;     //  Turn on the ADC
	MOVLW .129
	BCF   0x03,RP0
	MOVWF ADCON0
			;                              //   Bit 7 - Right Justified Sample
			;                              //   Bit 6 - Dont Use VRef
			;                              //   Bit 4:2 - Channel 0
			;                              //   Bit 1 - Do not Start
			;                              //   Bit 0 - Turn on ADC
			;
			;#ifdef LCD
			;  LCD_Init();          
	CALL  LCD_Init
			;  lcdWriteln ("Test");
	MOVLW .6
	MOVWF p_2
	CALL  lcdWriteln
			;  Delay10ms (100);
	MOVLW .100
	CALL  Delay10ms
			;  LCD_CLEAR;
	MOVLW .1
	CALL  lcdCommand
	MOVLW .16
	CALL  Delay100us
			;#endif
			;
			;  InitServo();
	CALL  InitServo
			;  ServoStart = 0;
	BCF   0x30,ServoStart
			;  SERVO = 0;
	BCF   0x03,RP0
	BCF   0x05,SERVO
			;
			;  // Init Timer1;
			;  TMR1L = 0xFF;
	MOVLW .255
	MOVWF TMR1L
			;  TMR1H = 0;
	CLRF  TMR1H
			;  T1CON = 0b00000001; // Resume counting;
	MOVLW .1
	MOVWF T1CON
			;  TMR1IF = 0;           
	BCF   0x0C,TMR1IF
			;
			;  SET_RP0;
			;  PIE1 = 1; 
	MOVLW .1
	BSF   0x03,RP0
	MOVWF PIE1
			;
			;  PEIE = 1;
	BSF   0x0B,PEIE
			;  GIE = 1;
	BSF   0x0B,GIE
			;
			;  while (1) {
			;    clrwdt(); 
m033	CLRWDT
			;    ReadAndOutputAvailableChannels();
	CALL  ReadAndOutputAvailableChannels
			;
			;  };
	GOTO  m033
			;}
			;
			;#pragma origin 0x3FF
	ORG 0x03FF
			;// This is a dummy - actual procedure is preset in chip and will override
			;// A change of 1 causes about 1% change in frequency
			;char GetOsccal() {return 0x0;}
GetOsccal
	RETLW .0

	END


; *** KEY INFO ***

; 0x0004   54 word(s)  5 % : serverX
; 0x004D    8 word(s)  0 % : Delay100us
; 0x0055   10 word(s)  0 % : Delay10ms
; 0x005F   22 word(s)  2 % : lcdWrite
; 0x0075   20 word(s)  1 % : lcdCommand
; 0x0089    9 word(s)  0 % : lcdCommand8
; 0x0092   22 word(s)  2 % : lcdProgram
; 0x003A   19 word(s)  1 % : _const1
; 0x00A8   14 word(s)  1 % : lcdWriteln
; 0x00B6   16 word(s)  1 % : LCD_Init
; 0x00C6   59 word(s)  5 % : WriteNum
; 0x0101   40 word(s)  3 % : WriteSNum
; 0x0129    5 word(s)  0 % : InitServo
; 0x012E   25 word(s)  2 % : ReadADC
; 0x0147   27 word(s)  2 % : ReadChannels
; 0x0162   40 word(s)  3 % : ReadAndOutputAvailableChannels
; 0x018A    8 word(s)  0 % : Beep
; 0x03FF    1 word(s)  0 % : GetOsccal
; 0x0192   50 word(s)  4 % : main

; RAM usage: 20 bytes (14 local), 44 bytes free
; Maximum call level: 4 (+1 for interrupt)
; Total of 450 code words (43 %)
